#pragma once
/*
 * Hm.CppInvoke ver 2.122
 * Copyright (c) 2021-2024 Akitsugu Komiyama
 * under the MIT License
 */

#include <windows.h>
#include <string>
#include <exception>
#include <stdexcept>
#include <vector>
#include <map>
#include <variant>
#include <tuple>
#include <functional>
#include <set>
#include <optional>
#include <memory>

#include "HmCppInvokeConvertString.h"

namespace Hidemaru {
#ifdef FLOATMACRO_COMPILE
    /// <summary>
    /// Gۂ̐l^
    /// </summary>
    using THmNumber = double;
#else
    /// <summary>
    /// Gۂ̐l^
    /// </summary>
    using THmNumber = intptr_t;
#endif

    /// <summary>
    /// Gۃ}Nϐ̎肤^B{l^^݂̂̑zB
    /// nullptr_t^͗pȂƁB
    /// </summary>
    using THmMacroVariable = std::variant<nullptr_t, THmNumber, std::wstring>;

    /// <summary>
    /// Macron\bh̕Ԃl̃\bhɊ܂܂G[^B
    /// std::nullopt ȂG[ȂA炩̃G[exception^ĂB
    /// </summary>
    using THmMacroResultError = std::optional<std::exception>;

    /// <summary>
    /// Hm.Macro.Exec.doMethod(...) \bh̑Qł֐̌^B
    /// </summary>
    using THmMacroDoMethodType = THmNumber (*)(std::wstring message_parameter);
}

namespace Hidemaru {

    /// <summary>
    /// Hm̊{ƂȂNX
    /// </summary>
    class THm {
    public:
        THm();

    private:
        // Hm Rs[֎~ɂĂB
        THm(const THm& src) = delete;
        void operator =(const THm& src) = delete;

    private:
        static double hm_version;
        static double QueryFileVersion(wchar_t* path);
    public:
        /// <summary>
        /// Gۃo[W̎擾
        /// </summary>
        /// <returns>Gۃo[W</returns>
        double getVersion();
    private:
        bool setVersion();

    private:
        // Gۂ̃EBhEnh
        using PFNGetCurrentWindowHandle = HWND(WINAPI*)();
        static PFNGetCurrentWindowHandle Hidemaru_GetCurrentWindowHandle;
    private:
        static HMODULE hHideExeHandle;
    public:
        /// <summary>
        /// Ă΂ꂽvZX݂̌̏GۃGfB^̃EBhEnhԂ܂B
        /// </summary>
        /// <returns>݂̏GۃGfB^̃EBhEnh</returns>
        HWND getWindowHandle();

    private:
        static wchar_t wszHidemaruFullPath[MAX_PATH];
    public:
        /// <summary>
        /// ݎs̏GۃGfB^{̂̃tpXԂ܂B
        /// </summary>
        /// <returns>ݎs̏GۃGfB^{̂̃tpX</returns>
        std::wstring getHidemaruFullPath();

    public:
        class TEdit;
#include "HmCppInvokeEdit.h"
    public:
        /// <summary>
        /// GfB^ҏWgnBOԂ̑ցB
        /// </summary>
        TEdit Edit;

    public:
        class TMacro;
#include "HmCppInvokeMacro.h"
    public:
        /// <summary>
        /// }NnBOԂ̑ցB
        /// </summary>
        TMacro Macro;

    public:
        class TFile;
#include "HmCppInvokeFile.h"
    public:
        /// <summary>
        /// t@CnBOԂ̑ցB
        /// </summary>
        TFile File;

    public:
        class TOutputPane;
#include "HmCppInvokeOutputPane.h"

    public:
        /// <summary>
        /// AEgvbggnBOԂ̑ցB
        /// </summary>
        TOutputPane OutputPane;

    public:
        class TExplorerPane;
#include "HmCppInvokeExplorerPane.h"
    public:
        /// <summary>
        /// t@C}l[WgnBOԂ̑ցB
        /// </summary>
        TExplorerPane ExplorerPane;


    private:
        class TDllBindType;
#include "HmCppInvokeDllBindType.h"
    private:
        TDllBindType DllBindType;

    public:
        bool funcDllExport();

    public:
        class TDllFuncCalledType;
#include "HmCppInvokeDllFuncCalledType.h"
    public:
        TDllFuncCalledType DllFuncCalledType;
    };
};

namespace Hidemaru {
    extern Hidemaru::THm Hm;
}


