#pragma once
/*
 * Copyright (c) 2021-2022 Akitsugu Komiyama
 * under the MIT License
 */

#include <string>

namespace Hidemaru {
	namespace Text {

		/// <summary>
		/// 悭镶GR[hϊn
		/// </summary>
		class Encoding {
		public:
			/// <summary>
			/// ustring^utf8vuwstring^utf16v
			/// </summary>
			static std::wstring utf8_to_utf16(const std::string& text);

			/// <summary>
			/// uwstring^utf16vustring^utf8v
			/// </summary>
			static std::string utf16_to_utf8(const std::wstring& text);

			/// <summary>
			/// ustring^cp932vuwstring^utf16v
			/// <para>(mɂ932ł͂ȂVXeOEMR[hy[WBWindows{ꃂ[h932)</para>
			/// </summary>
			static std::wstring cp932_to_utf16(const std::string& text);

			/// <summary>
			/// uwstring^utf16vustring^cp932v
			/// <para>(mɂ932ł͂ȂVXeOEMR[hy[WBWindows{ꃂ[h932)</para>
			/// </summary>
			static std::string utf16_to_cp932(const std::wstring& text);
		};
	}
}